// compute one scan line of mandelbrot set

#include "mandel.h"

int mandelLine(double originX, double originY, double escape_radius, double x,double y,double step,int maxdwell,int w,int * buf)
{
	register double Zr, Zi;
	register double tmp1, tmp2;
	register int dwell;
	int i;
	int total;
	
	total = 0;

	for ( i = 0; i < w; x += step, i++ ) {
		Zr = originX; Zi = originY;
		for (dwell = 0; dwell < maxdwell; dwell++) {
			tmp1 = Zr * Zr;
			tmp2 = Zi * Zi;
			Zi = ( 2.0 * Zr * Zi ) + y ;
			Zr = tmp1 - tmp2 + x ;
			if ((tmp1 + tmp2) > escape_radius ) break;
		}
		if (dwell == maxdwell)
			buf[i] = -1;
		else
			buf[i] = dwell;
		total += dwell;
	}
	return total;
}
